#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include <limits.h>
#include <inttypes.h>

int E,V,s,t;
struct edge { int u, v, c; };
struct edge edges[10010];
int64_t d[6000];
bool chgt;

void relax(struct edge *e) {
	if (d[e->u] == INT64_MAX) return;
	int64_t tmp = (int64_t)d[e->u] + (int64_t)e->c;
	//fprintf(stderr, "relax %d (%d->%d): %lld ->  %lld (%lld + %d)\n", e-edges, e->u, e->v, d[e->v], tmp, d[e->u], e->c);
	if (tmp < d[e->v]) {
		d[e->v] = tmp;
		if (e->v == t) { chgt = 1; }
	}
}

int main() {
	while (true) {
		scanf("%d %d %d %d", &E, &V, &s, &t);
		s--; t--;
		if (V == 0) break;
		int i,j;
		for (i=0; i<V; i++) d[i] = INT64_MAX;
		d[s] = 0;
		for (i=0; i<E; i++) {
			double tmp;
			scanf("%d %d %lf", &edges[i].u, &edges[i].v, &tmp);
			edges[i].u--;
			edges[i].v--;
			edges[i].c = - (int)(tmp*1000);
		}
		for (i=0; i<V*2+1; i++) {
			chgt = 0;
			for (j=0; j<E; j++) relax(edges+j);
		}
		if (chgt) printf("TRUE\n");
		else printf("FALSE\n");
	}
	return 0;
}
